*******************************************************
* Program: BCODE.PRG
*
* Author: Jon Walker
*
* Bar code interface to print on an Epson type printer.
* Multi-strike graphics create very good bar codes!
*
* This program has been tested on:
*    Alps Allegro 24
*    Epson LX-80
*

set talk off
set status off
set scoreboard off

do while .T.
   clear 
   a=space(9)
   @ 10,10 say "Code39 label to print" get a picture "@!"
   @ 11,10 say "(ESC quits)"
   read

   b=readkey()
   if b=12 .or. b=268 .or. len(trim(a))=0
      return
   endif

   if printstatus()
   
      *** get the bit pattern
      p=code39(trim(a))

      if len(p)=0
         loop
      endif
      
      *** Now print it out
      set print on
      set console off
    
      *** calculate N1 and N2 values for graphics command
      n1 = len(p) % 256
      n2 = int(len(p)/256)


      *** set printer to 2/216 lines per inch
      ? chr(27)+chr(51)+chr(2)

      *** print each character of bar code several
      *** times to create nice dark lines
      for h = 1 TO 12

         *** Set the printer to graphics and tell
         *** how many dots wide it is
         ?? chr(27)+chr(76)+chr(n1)+chr(n2)

         *** If the text printed per statement is 
         *** greater than 255 then garbage is sent
         *** along with the data so we will print
         *** out a block of the data instead
         for i=1 to int(len(p)/251)+1
            ?? substr(p,(i-1)*250+1,250)
         endfor

         *** advance printer 1/15" every 4th pass
         if h % 4 = 0
            ?? chr(27)+chr(74)+chr(12)
         endif

         *** Advance the paper
         ?
      endfor

      *** Advance the paper and print out the
      *** human readable text
      ? chr(27)+chr(74)+chr(14)
      ? space(len(a)/2)+a

      *** Reset the printer to 6 lines per inch
      ?? chr(27)+chr(74)+chr(36)+chr(27)+chr(50)

      set print off
      set console on

   endif
enddo

return
